#include <gtk/gtk.h>
#include "soundNode.h"
#include "gui.h"
#include "cmdparse.h"
#include <iostream.h>
#include <string.h>
#include <stdio.h>


void cmdparse(gchar * command)
{
	int i, j; i=j=0;
	int M1ID, M2ID;
	int M1, M2, T1, T2; char cT1, cT2, dummy; int parms;
	int Type; int Dbgterm;
	char cT; int M, T;
	
	g_strup(command);
	g_strchug(command);
	if (strlen(command)==0) return;
	switch (command[0])
	{
	case 'A':
		if (strlen(command)<2) Type = 2;
		else
		{
			Type = int(g_strtod(command+1,NULL));
		}
		New_Mod(Type);
		forcePaint();
		break;
	case '@':
		if (strlen(command)<2) Dbgterm = 0;
		else
		{
			Dbgterm = int(g_strtod(command+1,NULL));
		}
		cout << "Input term " << Dbgterm << " connects to " << I_TERM_WIRE(Dbgterm) << endl;
		cout << "Output term " << Dbgterm << " connects to " << O_TERM_WIRE(Dbgterm) << endl;
		break;
	case 'D':
		// syntax D 100A - disconnects first output terminal on module 100
		if (strlen(command)<2){cout << "syntax error: " << command << endl; break;}
		parms = sscanf(command+1, "%d %c", &M, &cT);
		if (parms != 2)
		{ cout << "D does not take " << parms << " parameters : " << command << endl; break;}
		cT -= 'A'; T = cT;
		
		j=0; for (i=0;i<MAX_MODULES;i++)
		{
			if (MOD[i]==NULL) continue;
			if (MOD[i]->UID == M) {M=i;j=1;}
		}
		
		if (j==0)
		{ cout << "Module# " << M << " does not exist." << endl; break;}
		if (T < 0 || T > 3)
		{ cout << "Invalid terminal number in " << command << endl; break;}
		cout << "Disconnecting module# " << M << " output terminal " << T << endl;
		GET_MODGRAPH_LOCK();
		cut_OTERM(IO_FROM_MOD_TERM(M,T));
		assignModuleTiers();
		RELEASE_MODGRAPH_LOCK();
		forcePaint();
		break;
	case 'R':
		// syntax R 101 - removes module if no connections are left to it, otherwise error
		if (strlen(command)<2){cout << "syntax error: " << command << endl; break;}
		M = int(g_strtod(command+1,NULL));
		j=0; for (i=0;i<MAX_MODULES;i++)
		{
			if (MOD[i]==NULL) continue;
			if (MOD[i]->UID == M) {M=i; j=1;}
		}
		if (j==0)
		{ cout << "Module# " << M << " does not exist." << endl; break;}
		
		if (MOD[M]->Type < 2)
		{
			cout << "Line In or Line Out modules cannot be removed or added." << endl;
			break;
		}
					
		j = 0; i = typeList[MOD[M]->Type].termMask;
		for (T=0;T<4;T++)
		{
			if (i & (0x80 >> T))
				if (is_I_WIRED(IO_FROM_MOD_TERM(M,T))) j = 1;
			if (i & (0x08 >> T))
				if (is_O_WIRED(IO_FROM_MOD_TERM(M,T))) j = 1;
		}
		if (j != 0)
		{ cout << "Can't remove module# " << M << " as it is still connected." << endl; break;}
		
		if (MOD_PARMBOX[M])
		{ cout << "Can't remove module# " << M << " as it still has an active dialog box" << endl;
			break; }
			
					
		GET_MODGRAPH_LOCK();
		Clean_Module(M);
		delete MOD[M]; MOD[M] = NULL;
		assignModuleTiers();
		RELEASE_MODGRAPH_LOCK();
		forcePaint();
		break;
	case 'C':
		if (strlen(command)<2){cout << "syntax error: " << command << endl; break;}
		// expects form C 101-123AB
		cT1 = cT2 = 'A';
		parms = sscanf(command+1, "%d%c%d %c %c", &M1, &dummy, &M2, &cT1, &cT2);
		if (parms != 5)
		{ cout << "C does not take " << parms << " parameters : " << command << endl; break;}
		cT1 -= 'A'; cT2 -= 'A';
		T1 = cT1; T2 = cT2;
		if ( (T1 < 0 || T2 < 0 ) || (T1 > 3 || T2 > 3) )
		{ cout << "Invalid terminal number in " << command << endl; break; }
		j = 0; M1ID = M1; M2ID = M2;
		for (i=0;i<MAX_MODULES;i++)
		{
			if (MOD[i]==NULL) continue;
			if (MOD[i]->UID == M1) {M1 = i; j = 1; break;} 
		}
		if (j == 0)
		{ cout << "Module ID# " << M1ID << " does not exist." << endl; break;}
		j = 0;
		for (i=0;i<MAX_MODULES;i++)
		{
			if (MOD[i]==NULL) continue;
			if (MOD[i]->UID == M2) {M2 = i; j = 1; break;}
		}
		
		if (j==0)
		{ cout << "Module ID# " << M2ID << " does not exist." << endl; break;}
		
		// check against module type bitmask for terminal existence
		j = typeList[MOD[M1]->Type].termMask;
		if (! (j & (0x08 >> T1) ) )
		{ cout << "Output terminal " << T1 << " of module " << M1ID << " does not exist." << endl;
			break;}
		
		j = typeList[MOD[M2]->Type].termMask;
		if (! (j & (0x80 >> T2) ) )
		{ cout << "Input terminal " << T2 << " of module " << M2ID << " does not exist." << endl;
			break;}
		
		cout << "Wiring module# " << M1 << " term " << T1 << " to module# " << M2 << " term " << T2
					<< endl;
		GET_MODGRAPH_LOCK();

		cut_ITERM(IO_FROM_MOD_TERM(M2,T2));
		cut_OTERM(IO_FROM_MOD_TERM(M1,T1));
		make_IO_WIRE( IO_FROM_MOD_TERM(M2,T2),IO_FROM_MOD_TERM(M1,T1));
		assignModuleTiers();
		RELEASE_MODGRAPH_LOCK();
		forcePaint(); 
		break;	
	default:
		cout << "unrecognized command " << command << endl;
	};
	
}
