// these inline functions must be static //
// so that linking errors don't happen ////
// every object file will contain it's ////
// own copy, but so what? /////////////////

inline static int I_TERM_WIRE (int i)
{
	g_assert(i >= 0 && i < TERMS_I_OR_O);
	return I_TERM_CONNECT[i];
}

inline static int O_TERM_WIRE (int o)
{
	g_assert(o >= 0 && o < TERMS_I_OR_O);
	return O_TERM_CONNECT[o];
}

inline static gboolean is_I_WIRED (int i)
{
	return (I_TERM_WIRE(i)!=-1);
}

inline static gboolean is_O_WIRED (int o)
{
	return (O_TERM_WIRE(o)!=-1);
}


inline static gboolean is_IO_WIRE (int i, int o)
{
	if (I_TERM_WIRE(i)==-1) return FALSE;
	if (O_TERM_WIRE(o)==-1) return FALSE;
	if (I_TERM_WIRE(i) == o)
	{
		g_assert(O_TERM_WIRE(o)==i);
		return TRUE;
	}
	return FALSE;
}


inline static void make_IO_WIRE (int i, int o)
{
	g_assert(i >= 0 && i < TERMS_I_OR_O);
	g_assert(o >= 0 && o < TERMS_I_OR_O);
	I_TERM_CONNECT[i]=o;
	O_TERM_CONNECT[o]=i;
}

inline static void cut_IO_WIRE (int i, int o)
{
	if (is_IO_WIRE(i,o))
		I_TERM_CONNECT[i]=O_TERM_CONNECT[o]=-1;
}

inline static int IO_FROM_MOD_TERM(int M, int T)
{
	return (M << 2) + T;
}

inline static int MOD_FROM_IO(int IO)
{
	return (IO>>2);
}

inline static void cut_ITERM (int I)
{
	int O = I_TERM_WIRE(I); if (O != -1) cut_IO_WIRE(I,O);	
}

inline static void cut_OTERM (int O)
{
	int I = O_TERM_WIRE(O); if (I != -1) cut_IO_WIRE(I,O);
}
