#include <gtk/gtk.h>
#include <iostream.h>
#include "soundNode.h"
#include "gui.h"
#include "cardfeed.h"
#include "loopStore.h"
#include <pthread.h>
#include <sched.h>
#include <unistd.h>
#include <string.h>
#include <getopt.h>
#include <stdlib.h>
#include <ctype.h>


void * audio_thread_start(void * V);

pthread_t audio_thread;

extern char * optarg;

int main(int argc, char * argv[])
{
	cout << "I compiled" << endl;
	gtk_init(&argc, &argv);
	Init_SoundNode_Data();
	initLoops();
	char c; int bb;
	
	while ( (c = getopt(argc, argv, "b:B:") ) != EOF)
	{
	switch(tolower(c))
		{
		case 'b':
			bb = atoi(optarg);
			if (bb < 0) break;
			if (bb > 5) break;
			sound_buffer_size = fs[bb];
			sound_chunk_size = sound_buffer_size/2;
			break;
		default:
			break;
		}	
	}
	
	cout << "Sound buffer size: " << sound_buffer_size << " bytes." << endl;
	open_sound(44100, 16, 2, 5, sound_buffer_size);
	sound_chunk_size = sound_buffer_size/2;
	Init_Chunkheap();
	mainGui theMan;
	if (pthread_create(&audio_thread, NULL, audio_thread_start, NULL))
	{
		cout << "Audio thread creation failed!" << endl;
		close_sound(); exit(1);
	}
	gtk_main();
	close_sound();
	Clean_SoundNode_Data();
	cleanLoops();
	exit(0);
}

void * audio_thread_start(void * V)
{
	cout << "audio thread started!" << endl;
	// attempt to gain SCHED_FIFO priority if possible
	// can only do it if ran as root (i think)
	sched_param schp;
	memset(&schp, 0, sizeof(schp));
	schp.sched_priority = sched_get_priority_max(SCHED_FIFO);
	if (sched_setscheduler(0,SCHED_FIFO, &schp) != 0) 
	{
		cout << "Can't get realtime priority for audio thread." << endl;
	}
	
	
	int i;
	while (1)
	{
		if (0 != read_sound())
		{
			cout << "Audio thread terminating!" << endl; exit(0);
		}
		GET_MODGRAPH_LOCK();
		// volatile declaration had BETTER work!
		for (i=0;i<MOD_EXEC_NUM;i++)
		{
			Pump_Module(MOD_EXEC_ORDER[i]);
		}
		
		RELEASE_MODGRAPH_LOCK();
		write_sound();
	}
}
